'use strict';

const t = require('@babel/types');

function _interopNamespaceCompat(e) {
  if (e && typeof e === 'object' && 'default' in e) return e;
  const n = Object.create(null);
  if (e) {
    for (const k in e) {
      n[k] = e[k];
    }
  }
  n.default = e;
  return n;
}

const t__namespace = /*#__PURE__*/_interopNamespaceCompat(t);

function index({ types: tt }) {
  return {
    visitor: {
      CallExpression(path, { opts }) {
        const callee = path.node.callee;
        const { callChains = [] } = opts;
        const [obj, ...fns] = callChains;
        if (tt.isIdentifier(callee, { name: obj })) {
          path.remove();
        }
        const isCallName = tt.isMemberExpression(callee) && tt.isIdentifier(callee.property) && fns.includes(callee.property.name);
        if (isIdentifierRecursive(callee, obj) && isCallName) {
          path.remove();
        }
      }
    }
  };
}
function isIdentifierRecursive(node, name) {
  if (!node)
    return false;
  if (t__namespace.isIdentifier(node, { name })) {
    return true;
  } else if (t__namespace.isMemberExpression(node)) {
    return isIdentifierRecursive(node.object, name);
  } else if (t__namespace.isCallExpression(node)) {
    return isIdentifierRecursive(node.callee, name);
  } else {
    return false;
  }
}

module.exports = index;
